package com.sksamuel.scoot.rest.client

import com.sksamuel.scoot.rest.Get
import com.fasterxml.jackson.databind.ObjectMapper
import com.fasterxml.jackson.module.scala.DefaultScalaModule
import com.fasterxml.jackson.datatype.hibernate3.Hibernate3Module

/** @author Stephen Samuel
  *
  * */
class RestClient(mapper: ObjectMapper) {

    def resource(path: String): Request = Request(mapper,
        path,
        Map.empty,
        NoCredentials,
        Map.empty,
        Map.empty,
        Get,
        None,
        None,
        Nil)
}

object RestClient {
    def apply() = {
        val mapper = new ObjectMapper
        mapper.registerModule(DefaultScalaModule)
        mapper.registerModule(new Hibernate3Module)
        new RestClient(mapper)
    }
    def apply(mapper: ObjectMapper) = new RestClient(mapper)
}







