package com.sksamuel.scoot.rest.jersey

import javax.ws.rs.Path
import com.sun.jersey.api.core.DefaultResourceConfig
import org.glassfish.grizzly.http.server.HttpServer
import com.sun.jersey.api.container.grizzly2.GrizzlyServerFactory
import org.scalatest.{FunSuite, BeforeAndAfter}

/** @author Stephen Samuel */
trait JerseySpec extends FunSuite with BeforeAndAfter {

    private var _server: HttpServer = _

    def initServer(baseURI: String, resources: AnyRef*) {
        resources.foreach(resource => require(resource.getClass.isAnnotationPresent(classOf[Path])))

        val rc = new DefaultResourceConfig
        import scala.collection.JavaConverters._
        rc.getSingletons.addAll(resources.asJava)
        rc.getSingletons.add(new ScalaObjectMapperProvider)

        _server = GrizzlyServerFactory.createHttpServer(baseURI, rc)
        _server.start()
    }

    after {
        stopServer()
    }

    def stopServer() {
        _server.stop()
    }
}
