package com.sksamuel.scoot.soa.mvc

import org.springframework.web.bind.annotation.{ExceptionHandler, ResponseBody}
import com.sksamuel.scoot.soa.HttpStatusException
import javax.servlet.http.HttpServletResponse

/** @author Stephen Samuel */
trait SpringMvcHttpStatusErrorHandling {

    @ExceptionHandler(Array(classOf[HttpStatusException]))
    @ResponseBody
    def handleException1(e: HttpStatusException, resp: HttpServletResponse) {
        resp.sendError(e.status, e.message.orNull)
    }

}
